<template>
  <div class="app-container">
    <el-card class="box-card app-container">
      <el-row slot="header">
        <el-col :span="20">
          <h3>{{ title }}</h3>
        </el-col>
        <el-col :span="4">
          <el-button type="primary" class="fr" @click="submit">
            Guardar
          </el-button>
        </el-col>
      </el-row>
      <el-form class="form" ref="fields" :rules="rules" :model="fields" label-position="top">
        <el-row :gutter="20">
          <el-col :span="16">
            <el-form-item label="Nombre" prop="name" :error="errors.name">
              <el-input v-model.trim="fields.name" placeholder="Nombre del cliente" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="Categoría" prop="category" :error="errors.category">
              <el-select
                v-model="fields.category"
                placeholder="Categorías">
                <el-option
                  v-for="(category, idx) in categories"
                  :key="idx"
                  :label="category"
                  :value="category">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="8">
            <el-form-item label="Vendedor" prop="defaultSalesMan" :error="errors.defaultSalesMan">
              <el-select
                v-model="fields.defaultSalesMan"
                filterable
                placeholder="Vendedor">
                <el-option
                  v-for="salesman in salesmen"
                  :key="salesman._id"
                  :label="salesman.name"
                  :value="salesman._id">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="Ruta" prop="route" :error="errors.route">
              <el-input v-model.trim="fields.route" placeholder="Nombre de la ruta" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="CUIT" prop="cuit" :error="errors.cuit">
              <el-input v-model.trim="fields.cuit" placeholder="00-0000000000-0" maxlength="15" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="16">
            <el-form-item label="Dirección" prop="addressLine" :error="errors.addressLine">
              <el-input v-model.trim="fields.addressLine" placeholder="Calle Falsa 123" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="Localidad" prop="city" :error="errors.city">
              <el-input v-model.trim="fields.city" placeholder="Lanús" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="8">
            <el-form-item label="Teléfono Principal" prop="tel1" :error="errors.tel1">
              <el-input v-model.trim="fields.tel1" placeholder="412341234" maxlength="15" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="Otro Teléfono" prop="tel2" :error="errors.tel2">
              <el-input v-model.trim="fields.tel2" placeholder="1512344567" maxlength="15" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="Descuento por Defecto (%)" prop="defaultDiscount" :error="errors.defaultDiscount">
              <el-input-number v-model.trim="fields.defaultDiscount" :min="0" :max="100" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-card>
  </div>
</template>

<script>
import api from "@/feathers";
import BaseForm from "@/common/base-form.mixin";
import AppAutocomplete from "@/common/app-autocomplete";

export default {
  name: "client-form",
  mixins: [BaseForm],
  props: {
    id: { type: String, required: false, default: null }
  },
  components: {
    AppAutocomplete
  },
  data() {
    const rules = {
      name: [
        { required: true, message: "Debe ingresar un nombre", trigger: "blur" }
      ],
      category: [{ type: "string", trigger: "blur" }],
      addressLine: [{ type: "string", required: false, trigger: "blur" }],
      city: [{ type: "string", required: false, trigger: "blur" }],
      route: [{ type: "string", required: false, trigger: "blur" }],
      defaultSalesMan: [
        {
          type: "string",
          message: "Debe ingresar un vendedor por defecto",
          required: true,
          trigger: "blur"
        }
      ],
      cuit: [
        {
          type: "string",
          pattern: /^\d{2}-\d{10}-\d$/,
          message: "Debe cumplir el formato 00-0000000000-00)",
          trigger: "blur"
        }
      ],
      tel1: [{ type: "string", required: false, trigger: "blur" }],
      tel2: [{ type: "string", required: false, trigger: "blur" }],
      defaultDiscount: [
        {
          type: "number",
          message: "Debe ingresar un valor numérico",
          trigger: "blur"
        }
      ]
    };
    const { fields, errors } = this.buildForm(rules);

    return {
      title: "",
      rules,
      errors,
      fields,
      categories: [],
      salesmen: []
    };
  },
  async created() {
    this.service = api.service("clients");

    if (this.id) {
      this.fields = await this.service.get(this.id);
      this.action = "update";
      this.title = `Actualizar ${this.fields.name}`;
    } else {
      this.action = "create";
      this.title = "Nuevo Cliente";
    }
    return Promise.all([this.getCategories(), this.getSalesmen()]);
  },
  methods: {
    async getCategories() {
      this.categories = await api.service("client-categories").find();
    },
    async getSalesmen() {
      this.salesmen = await api
        .service("salesmen")
        .find({ query: { $limit: -1 } });
    }
  }
};
</script>

<style lang="scss">
.el-card {
  &__header {
    margin: 0;
    paddiong: 10px 20px 4px 20px;
    h3 {
      margin: 0;
      padding: 10px 0px;
    }
  }
}
</style>
